Index: trunk/NEMO/OPA_SRC/DYN/dynkeg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 258)
@@ -14,4 +14,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -119,9 +120,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' keg  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' keg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynldf_bilap.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 258)
@@ -17,4 +17,5 @@
    USE trdmod_oce      ! ocean variables trends
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -237,9 +238,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' ldf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' ldf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 258)
@@ -22,4 +22,5 @@
    USE ldfslp          ! iso-neutral slopes available
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -81,5 +82,4 @@
       !! * Local declarations
       INTEGER ::   ji, jj, jk                 ! dummy loop indices
-      REAL(wp) ::   zua, zva                  ! temporary scalars
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
          zwk1, zwk2                ! work array used for rotated biharmonic
@@ -138,9 +138,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' ldf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' ldf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynldf_iso.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 258)
@@ -22,4 +22,5 @@
    USE ldfslp          ! iso-neutral slopes 
    USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -98,5 +99,5 @@
          zabe1, zabe2, zcof1, zcof2,   &  ! temporary scalars
          zmskt, zmskf, zbu, zbv,       &
-         zuah, zvah, zua, zva
+         zuah, zvah
       REAL(wp), DIMENSION(jpi,jpj) ::   &
          ziut, zjuf, zjvt, zivf,        & ! temporary workspace
@@ -259,9 +260,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' ldf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' ldf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynldf_lap.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynldf_lap.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynldf_lap.F90	(revision 258)
@@ -18,4 +18,5 @@
    USE trdmod_oce      ! ocean variables trends
    USE ldfslp          ! iso-neutral slopes 
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -136,9 +137,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' ldf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' ldf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 258)
@@ -14,4 +14,5 @@
    USE obcdyn          ! open boundary condition for momentum (obc_dyn routine)
    USE lbclnk          ! lateral boundary condition (or mpp link)
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -135,6 +136,8 @@
       !                                                ! ===============
 
-      IF(l_ctl)   WRITE(numout,*) ' nxt  - Un: ', SUM(un(2:nictl,2:njctl,1:jpkm1)*umask(2:nictl,2:njctl,1:jpkm1)), &
-      &                                  ' Vn: ', SUM(vn(2:nictl,2:njctl,1:jpkm1)*vmask(2:nictl,2:njctl,1:jpkm1))
+      IF(ln_ctl)   THEN
+         CALL prt_ctl(tab3d_1=un, clinfo1=' nxt  - Un: ', mask1=umask, &
+            &         tab3d_2=vn, clinfo2=' Vn: ', mask2=vmask)
+      ENDIF
 
    END SUBROUTINE dyn_nxt
Index: trunk/NEMO/OPA_SRC/DYN/dynspg_fsc.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_fsc.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_fsc.F90	(revision 258)
@@ -33,4 +33,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE cla_dynspg      ! cross land advection
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -337,7 +338,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         WRITE(numout,*) ' spg  - Ua: ', SUM( ua(2:nictl,2:njctl,1:jpkm1)*umask(2:nictl,2:njctl,1:jpkm1) ),   &
-            &                   ' Va: ', SUM( va(2:nictl,2:njctl,1:jpkm1)*vmask(2:nictl,2:njctl,1:jpkm1) )
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' spg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask)
       ENDIF
 
@@ -370,6 +371,6 @@
 
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         WRITE(numout,*) ' spg - ssh:', SUM( sshn(2:nictl,2:njctl)*tmask(2:nictl,2:njctl,1) )
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab2d_1=sshn, clinfo1=' spg  - ssh: ', mask1=tmask)
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynspg_fsc_atsk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_fsc_atsk.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_fsc_atsk.F90	(revision 258)
@@ -37,4 +37,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE cla_dynspg      ! cross land advection
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -354,7 +355,7 @@
          END DO
 
-         IF(l_ctl) THEN         ! print sum trends (used for debugging)
-            WRITE(numout,*) ' spg  - Ua: ', SUM( ua(2:nictl,2:njctl,1:jpkm1)*umask(2:nictl,2:njctl,1:jpkm1) ),   &
-               &                   ' Va: ', SUM( va(2:nictl,2:njctl,1:jpkm1)*vmask(2:nictl,2:njctl,1:jpkm1) )
+         IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+            CALL prt_ctl(tab3d_1=ua, clinfo1=' spg  - Ua: ', mask1=umask, &
+               &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask)
          ENDIF
 
@@ -398,6 +399,6 @@
       CALL lbc_lnk( sshn, 'T', 1. )
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         WRITE(numout,*) ' spg - ssh:', SUM( sshn(2:nictl,2:njctl)*tmask(2:nictl,2:njctl,1) )
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab2d_1=sshn, clinfo1=' spg  - ssh: ', mask1=tmask)
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 258)
@@ -20,4 +20,5 @@
    USE trdmod_oce      ! ocean variables trends
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -188,9 +189,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' vor  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' vor  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -342,9 +341,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' vor  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' vor  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -499,9 +496,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' vor  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' vor  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -662,9 +657,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:jpim1,2:jpjm1,1:jpkm1) * umask(2:jpim1,2:jpjm1,1:jpkm1) )
-         zva = SUM( va(2:jpim1,2:jpjm1,1:jpkm1) * vmask(2:jpim1,2:jpjm1,1:jpkm1) )
-         WRITE(numout,*) ' vor  een - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' vor  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynzad.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 258)
@@ -15,4 +15,5 @@
    USE trdmod_oce      ! ocean variables trends
    USE flxrnf          ! ocean runoffs
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -142,9 +143,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zad  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zad  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -255,9 +254,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zad  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zad  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_exp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 258)
@@ -18,4 +18,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -197,9 +198,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zdf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zdf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 258)
@@ -22,4 +22,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -79,5 +80,5 @@
          ikbu, ikbum1, ikbv, ikbvm1      ! temporary integers
       REAL(wp) ::   &
-         zrau0r, z2dt, zua, zva,      &  ! temporary scalars
+         zrau0r, z2dt,                &  ! temporary scalars
          z2dtf, zcoef, zzws, zrhs        !    "         "
       REAL(wp), DIMENSION(jpi,jpj) ::   &
@@ -355,9 +356,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zdf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zdf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_atsk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_atsk.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_atsk.F90	(revision 258)
@@ -19,4 +19,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -74,5 +75,5 @@
          ikbu, ikbum1, ikbv, ikbvm1      !    "         "      
       REAL(wp) ::   &
-         zrau0r, z2dt, zua, zva,       & !temporary scalars
+         zrau0r, z2dt,                 & !temporary scalars
          z2dtf, zcoef, zzws
       REAL(wp), DIMENSION(jpi,jpk) ::  &
@@ -338,9 +339,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zdf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zdf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_iso.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_iso.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_iso.F90	(revision 258)
@@ -21,4 +21,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -110,5 +111,5 @@
       REAL(wp) ::   &
          zrau0r, z2dt,                       & ! temporary scalars
-         z2dtf, zua, zva, zcoef, zzws
+         z2dtf, zcoef, zzws
       REAL(wp) ::   &
          zcoef0, zcoef3, zcoef4, zbu, zbv, zmkt, zmkf,   &
@@ -406,9 +407,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zua = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zva = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zdf  - Ua: ', zua-u_ctl, ' Va: ', zva-v_ctl
-         u_ctl = zua   ;   v_ctl = zva
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' zdf  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/wzvmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/wzvmod.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/wzvmod.F90	(revision 258)
@@ -12,4 +12,5 @@
    USE dom_oce         ! ocean space and time domain variables 
    USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -80,7 +81,5 @@
       !                                                ! ===============
 
-      IF(l_ctl) THEN                ! print mean trends (used for debugging)
-         WRITE(numout,*) ' w**2 -   : ', SUM( wn(2:nictl,2:njctl,1:jpkm1) * wn   (2:nictl,2:njctl,1:jpkm1) )
-      ENDIF
+      IF(ln_ctl)   CALL prt_ctl(tab3d_1=wn, clinfo1=' w**2 -   : ', mask1=wn)
 
    END SUBROUTINE wzv
@@ -131,7 +130,5 @@
       END DO
 
-      IF(l_ctl) THEN                ! print mean trends (used for debugging)
-         WRITE(numout,*) ' w**2 -   : ', SUM( wn(2:nictl,2:njctl,1:jpkm1) * wn   (2:nictl,2:njctl,1:jpkm1) )
-      ENDIF
+      IF(ln_ctl)   CALL prt_ctl(tab3d_1=wn, clinfo1=' w**2 -   : ', mask1=wn)
 
    END SUBROUTINE wzv
Index: trunk/NEMO/OPA_SRC/LDF/ldfeiv.F90
===================================================================
--- trunk/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 258)
@@ -22,4 +22,5 @@
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -162,7 +163,9 @@
       CALL lbc_lnk( aeiv, 'V', 1. )
 
-      IF(l_ctl)   WRITE(numout,*) ' eiv  - u: ', SUM( aeiu(1:nictl+1,1:njctl+1) ), ' v: ', SUM( aeiv(1:nictl+1,1:njctl+1) )
-
-
+      IF(ln_ctl)   THEN
+         CALL prt_ctl(tab2d_1=aeiu, clinfo1=' eiv  - u: ', ovlap=1)
+         CALL prt_ctl(tab2d_1=aeiv, clinfo1=' eiv  - v: ', ovlap=1)
+      ENDIF
+      
       ! ORCA R05: add a space variation on aht (=aeiv except at the equator and river mouth)
       IF( cp_cfg == "orca" .AND. jp_cfg == 05 ) THEN
@@ -178,8 +181,8 @@
             END DO
          END DO
-         IF(l_ctl) THEN
-            WRITE(numout,*)' aht  - u: ', SUM( ahtu(1:nictl+1,1:njctl+1) )
-            WRITE(numout,*)'      - v: ', SUM( ahtv(1:nictl+1,1:njctl+1) )
-            WRITE(numout,*)'      - w: ', SUM( ahtw(1:nictl+1,1:njctl+1) )
+         IF(ln_ctl) THEN
+            CALL prt_ctl(tab2d_1=ahtu, clinfo1=' aht  - u: ', ovlap=1)
+            CALL prt_ctl(tab2d_1=ahtv, clinfo1=' aht  - v: ', ovlap=1)
+            CALL prt_ctl(tab2d_1=ahtw, clinfo1=' aht  - w: ', ovlap=1)
          ENDIF
       ENDIF
@@ -327,5 +330,8 @@
       CALL lbc_lnk( aeiv, 'V', 1. )
 
-      IF(l_ctl)   WRITE(numout,*) ' eiv  - u: ', SUM( aeiu(1:nictl+1,1:njctl+1) ), ' v: ', SUM( aeiv(1:nictl+1,1:njctl+1) )
+      IF(ln_ctl)   THEN
+         CALL prt_ctl(tab2d_1=aeiu, clinfo1=' eiv  - u: ', ovlap=1)
+         CALL prt_ctl(tab2d_1=aeiv, clinfo1=' eiv  - v: ', ovlap=1)
+      ENDIF
 
       ! ORCA R05: add a space variation on aht (=aeiv except at the equator and river mouth)
@@ -342,8 +348,8 @@
             END DO
          END DO
-         IF(l_ctl) THEN
-            WRITE(numout,*) ' aht  - u: ', SUM( ahtu(1:nictl+1,1:njctl+1) )
-            WRITE(numout,*) '      - v: ', SUM( ahtv(1:nictl+1,1:njctl+1) )
-            WRITE(numout,*) '      - w: ', SUM( ahtw(1:nictl+1,1:njctl+1) )
+         IF(ln_ctl) THEN
+            CALL prt_ctl(tab2d_1=ahtu, clinfo1=' aht  - u: ', ovlap=1)
+            CALL prt_ctl(tab2d_1=ahtv, clinfo1=' aht  - v: ', ovlap=1)
+            CALL prt_ctl(tab2d_1=ahtw, clinfo1=' aht  - w: ', ovlap=1)
          ENDIF
       ENDIF
Index: trunk/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 258)
@@ -21,4 +21,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -480,7 +481,7 @@
       CALL lbc_lnk( wslpj, 'W', -1. )
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' slp  - u : ', SUM( uslp (1:nictl,1:njctl,:) ), ' v : ', SUM( vslp (1:nictl,1:njctl,:) )
-         WRITE(numout,*) '      - wi: ', SUM( wslpi(1:nictl,1:njctl,:) ), ' wj: ', SUM( wslpj(1:nictl,1:njctl,:) )
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab3d_1=uslp , clinfo1=' slp  - u : ', tab3d_2=vslp,  clinfo2=' v : ', kdim=jpk)
+         CALL prt_ctl(tab3d_1=wslpi, clinfo1=' slp  - wi: ', tab3d_2=wslpj, clinfo2=' wj: ', kdim=jpk)
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/SBC/bulk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/bulk.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/SBC/bulk.F90	(revision 258)
@@ -21,4 +21,5 @@
    USE phycst          ! physical constants
    USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -97,18 +98,17 @@
 
 # if ! defined key_ice_lim
-         IF(l_ctl) THEN         ! print mean trends (used for debugging)
-            WRITE(numout,*) ' Forcings '
-            WRITE(numout,*) ' qsr_oce  : ', SUM( qsr_oce (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' qsr_ice  : ', SUM( qsr_ice (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' qnsr_oce : ', SUM( qnsr_oce(1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' qnsr_ice : ', SUM( qnsr_ice(1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' evap     : ', SUM( evap    (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' precip   : ', SUM( tprecip (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) ) / rday
-            WRITE(numout,*) ' Snow     : ', SUM( sprecip (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) ) / rday
-            WRITE(numout,*) ' u-stress : ', SUM( taux    (1:nictl+1,1:njctl+1) * umask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' v-stress : ', SUM( tauy    (1:nictl+1,1:njctl+1) * vmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' sst      : ', SUM( zsst    (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*) ' sss      : ', SUM( zsss    (1:nictl+1,1:njctl+1) * tmask(1:nictl+1,1:njctl+1,1) )
-            WRITE(numout,*)
+         IF(ln_ctl) THEN         ! print mean trends (used for debugging)
+            CALL prt_ctl_info(' Forcings ')
+            CALL prt_ctl(tab2d_1=qsr_oce , clinfo1=' qsr_oce   : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=qsr_ice , clinfo1=' qsr_ice   : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=qnsr_oce, clinfo1=' qnsr_oce  : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=qnsr_ice, clinfo1=' qnsr_ice  : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=evap    , clinfo1=' evap      : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=tprecip , clinfo1=' precip    : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=sprecip , clinfo1=' Snow      : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=taux    , clinfo1=' u-stress  : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=tauy    , clinfo1=' v-stress  : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=zsst    , clinfo1=' sst       : ', mask1=tmask, ovlap=1)
+            CALL prt_ctl(tab2d_1=zsss    , clinfo1=' sss       : ', mask1=tmask, ovlap=1)
          ENDIF
 # endif   
Index: trunk/NEMO/OPA_SRC/SBC/flxblk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/flxblk.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/SBC/flxblk.F90	(revision 258)
@@ -24,4 +24,5 @@
    USE lbclnk
    USE albedo
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -319,5 +320,7 @@
 
       iday   = INT( zxday )
-      IF(l_ctl)   WRITE(numout,*) ' declin : iday ', iday, ' nfbulk= ', nfbulk
+
+      IF(ln_ctl) CALL prt_ctl_info('declin : iday ', ivar1=iday, clinfo2=' nfbulk= ', ivar2=nfbulk)
+
       !   computation of the solar declination, his sine and his cosine
       CALL flx_blk_declin( indaet, iday, zdecl )
Index: trunk/NEMO/OPA_SRC/SBC/ocesbc.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/ocesbc.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/SBC/ocesbc.F90	(revision 258)
@@ -13,18 +13,19 @@
    USE dom_oce        ! ocean space domain variables
    USE cpl_oce        ! coupled ocean-atmosphere variables
-   USE ice_oce
-   USE blk_oce
-   USE flx_oce
+   USE ice_oce        ! sea-ice variable
+   USE blk_oce        ! bulk variables
+   USE flx_oce        ! sea-ice/ocean forcings variables
    USE phycst         ! Define parameters for the routines
-   USE taumod
-   USE flxmod
-   USE flxrnf
+   USE taumod         ! surface stress forcing
+   USE flxmod         ! thermohaline fluxes
+   USE flxrnf         ! runoffs forcing
    USE tradmp         ! damping salinity trend
-   USE dtatem
-   USE dtasal
-   USE ocfzpt
-   USE lbclnk
-   USE lib_mpp
+   USE dtatem         ! ocean temperature data
+   USE dtasal         ! ocean salinity data
+   USE ocfzpt         ! surface ocean freezing point
+   USE lbclnk         ! ocean lateral boundary condition
+   USE lib_mpp        ! distribued memory computing library
    USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
@@ -301,5 +302,5 @@
       !!----------------------------------------------------------------------
       !! * Modules used
-      USE cpl_oce 
+      USE cpl_oce       ! coupled ocean-atmosphere variables
 
       !! * Arguments
@@ -400,13 +401,13 @@
       !!----------------------------------------------------------------------
       !! * Modules used
-      USE daymod
+      USE daymod                 ! calendar
 #if ! defined key_dtasst
-      USE dtasst, ONLY : rclice
+      USE dtasst, ONLY : rclice  ! sea surface temperature data
 #endif
 #if defined key_flx_bulk_monthly || defined key_flx_bulk_daily
-      USE blk_oce
+      USE blk_oce                ! bulk variables
 #endif
 #if defined key_flx_forced_daily
-      USE flx_oce
+      USE flx_oce                ! sea-ice/ocean forcings variables
 #endif
 
@@ -769,4 +770,5 @@
       REAL(wp), DIMENSION(jpi,jpj)  :: zsss, zfreeze
       REAL(wp) ::   zerp, ztrp, zsrp
+      CHARACTER (len=71) :: charout
 #if defined key_dynspg_fsc
       REAL(wp) ::   zwei
@@ -852,5 +854,9 @@
       IF( lk_mpp )   CALL mpp_sum( aplus  )   ! sums over the global domain
       IF( lk_mpp )   CALL mpp_sum( aminus )
-      IF(l_ctl)   WRITE(numout,*) ' oce_sbc_dmp : a+ = ', aplus, ' a- = ', aminus
+
+      IF(ln_ctl)   THEN
+         WRITE(charout,FMT="('oce_sbc_dmp : a+ = ',D23.16, ' a- = ',D23.16)") aplus, aminus
+         CALL prt_ctl_info(charout)
+      ENDIF
 
       zadefi = MIN( aplus, aminus )
Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 258)
@@ -24,4 +24,5 @@
    USE dynspg_fsc      ! 
    USE dynspg_fsc_atsk ! 
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -299,9 +300,7 @@
       ENDIF
 
-      IF(l_ctl) THEN
-         zta = SUM( ta(2:nictl,2:njctl,1:jpkm1) * tmask(2:nictl,2:njctl,1:jpkm1) )
-         zsa = SUM( sa(2:nictl,2:njctl,1:jpkm1) * tmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' had  - Ta: ', zta-t_ctl, ' Sa: ', zsa-s_ctl
-         t_ctl = zta   ;   s_ctl = zsa
+      IF(ln_ctl)   THEN
+          CALL prt_ctl(tab3d_1=ta, clinfo1=' centered2 had  - Ta: ', mask1=tmask, &
+             &         tab3d_2=sa, clinfo2=' Sa: ', mask2=tmask, clinfo3='tra')
       ENDIF
 
@@ -400,9 +399,7 @@
       ENDIF
 
-      IF(l_ctl) THEN
-         zta = SUM( ta(2:nictl,2:njctl,1:jpkm1) * tmask(2:nictl,2:njctl,1:jpkm1) )
-         zsa = SUM( sa(2:nictl,2:njctl,1:jpkm1) * tmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' zad  - Ta: ', zta-t_ctl, ' Sa: ', zsa-s_ctl, ' centered2'
-         t_ctl = zta   ;   s_ctl = zsa
+      IF(ln_ctl)   THEN
+          CALL prt_ctl(tab3d_1=ta, clinfo1=' centered2 zad  - Ta: ', mask1=tmask, &
+             &         tab3d_2=sa, clinfo2=' Sa: ', mask2=tmask, clinfo3='tra')
       ENDIF
 
